unit Unit1;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ImageHlp, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    ListView1: TListView;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure ListDLLExports(const FileName: string; List: TStrings); 
type 
  TDWordArray = array [0..$FFFFF] of DWORD; 
var 
  imageinfo: LoadedImage;
  pExportDirectory: PImageExportDirectory; 
  dirsize: Cardinal;
  pDummy: PImageSectionHeader; 
  i: Cardinal; 
  pNameRVAs: ^TDWordArray; 
  Name: string; 
begin 
  List.Clear; 
  if MapAndLoad(PChar(FileName), nil, @imageinfo, True, True) then 
  begin 
    try 
      pExportDirectory := ImageDirectoryEntryToData(imageinfo.MappedAddress, 
        False, IMAGE_DIRECTORY_ENTRY_EXPORT, dirsize); 
      if (pExportDirectory <> nil) then 
      begin 
        pNameRVAs := ImageRvaToVa(imageinfo.FileHeader, imageinfo.MappedAddress, 
          DWORD(pExportDirectory^.AddressOfNames), pDummy); 
        for i := 0 to pExportDirectory^.NumberOfNames - 1 do 
        begin 
          Name := PChar(ImageRvaToVa(imageinfo.FileHeader, imageinfo.MappedAddress, 
            pNameRVAs^[i], pDummy)); 
          List.Add(Name); 
        end; 
      end; 
    finally 
      UnMapAndLoad(@imageinfo); 
    end; 
  end; 
end; 

procedure TForm1.Button1Click(Sender: TObject); 
var 
  List: TStrings; 
  i: Integer; 
  s: string; 
begin
  if not OpenDialog1.Execute then exit;
  List := TStringList.Create;
  try
    ListDLLExports(OpenDialog1.FileName, List);
    Label1.Caption := IntToStr(list.Count) + ' fonctions dans '
                  + ExtractFileName(OpenDialog1.FileName);
    Label1.Visible := true;
    for i := 0 to List.Count - 1 do
      with ListView1.Items.Add do begin
         Caption := IntToStr(i);
         SubItems.Add(List[i]);
      end; // with
  finally
    List.Free;
  end;
end;


end.
